Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/MultiComponentVectorEncoding.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/MultiComponentVectorEncoding.cs	(revision 9494)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/MultiComponentVectorEncoding.cs	(revision 9495)
@@ -37,5 +37,14 @@
 
     [Storable]
-    public ItemList<PackingInformation> PackingInformations {get;set;}   
+    public ObservableDictionary<int, ItemList<PackingInformation>> PackingInformations {get;set;}
+
+    public int NrOfBins { get { return PackingInformations.Count; } }
+    public int NrOfItems { 
+      get {
+        int nrOfItems = 0;
+        foreach (var entry in PackingInformations) { nrOfItems += entry.Value.Count; }
+        return nrOfItems;
+      } 
+    }
 
     [StorableConstructor]
@@ -43,5 +52,8 @@
     protected MultiComponentVectorEncoding(MultiComponentVectorEncoding original, Cloner cloner)
       : base(original, cloner) {
-        this.PackingInformations = cloner.Clone(original.PackingInformations);
+        this.PackingInformations = new ObservableDictionary<int,ItemList<PackingInformation>>();
+      foreach (var entry in original.PackingInformations) {
+        this.PackingInformations[entry.Key] = cloner.Clone(entry.Value);
+      }
     }
     public override IDeepCloneable Clone(Cloner cloner) {
@@ -51,5 +63,5 @@
     public MultiComponentVectorEncoding()
       : base() {
-        PackingInformations = new ItemList<PackingInformation>();
+        PackingInformations = new ObservableDictionary<int, ItemList<PackingInformation>>();
     }
 
@@ -57,6 +69,10 @@
       StringBuilder sb = new StringBuilder();
       sb.Append("[ ");
-      foreach (var pi in PackingInformations) {
-        sb.Append(pi.ToString() + " ");        
+      foreach (var gi in PackingInformations) {
+        sb.Append("g#" + gi.Key.ToString() + "{ ");
+        foreach (var pi in gi.Value) {
+          sb.Append(pi.ToString() + " ");
+        }
+        sb.Append("} ");
       }
       sb.Append("]");
@@ -85,18 +101,14 @@
   public class PackingInformation : Item {
     [Storable]
-    public int ItemIndex { get; set; }
-    [Storable]
-    public int AssignedBin { get; set; }
+    public int ItemID { get; set; }
     [Storable]
     public bool Rotated { get; set; }
 
-    public PackingInformation(int itemIndex, int assignedBin, bool rotated) {
-      this.AssignedBin  = assignedBin;
-      this.ItemIndex   = itemIndex;
+    public PackingInformation(int itemID, bool rotated) {
+      this.ItemID   = itemID;
       this.Rotated      = rotated;
     }     
     public PackingInformation(PackingInformation original) {
-      this.AssignedBin = original.AssignedBin;
-      this.ItemIndex = original.ItemIndex;
+      this.ItemID = original.ItemID;
       this.Rotated = original.Rotated;
     }
@@ -106,6 +118,5 @@
     protected PackingInformation(PackingInformation original, Cloner cloner)
       : base(original, cloner) {
-        this.AssignedBin  = original.AssignedBin;
-        this.ItemIndex   = original.ItemIndex;
+        this.ItemID   = original.ItemID;
         this.Rotated      = original.Rotated;
     }
@@ -115,5 +126,6 @@
 
     public override string ToString() {
-      return String.Format("({0}, {1}, {2}) ", ItemIndex, AssignedBin, Rotated);
+      return String.Format("{0}", ItemID.ToString());
+      //return String.Format("({0}, {1}) ", ItemID, Rotated ? "t" : "f");
     }
 
@@ -121,5 +133,5 @@
       PackingInformation pi = obj as PackingInformation;
       if (pi != null)
-        return this.ItemIndex.Equals(pi.ItemIndex) && this.AssignedBin.Equals(pi.AssignedBin) && this.Rotated.Equals(pi.Rotated);
+        return this.ItemID.Equals(pi.ItemID) && this.Rotated.Equals(pi.Rotated);
 
       return false;
@@ -130,18 +142,23 @@
     }
 
-    public static ItemList<PackingInformation> CreateListRandomly(int items, int lowerBound, IRandom random) {
-      Permutation permutation = new Permutation(PermutationTypes.Absolute, items, random);
-      var result = new ItemList<PackingInformation>();
-      foreach (int itemIndex in permutation) {
-        result.Add(new PackingInformation(itemIndex, random.Next(0, lowerBound + 1), random.Next(0, 100) > 60 ? true : false));
+    public static ObservableDictionary<int, ItemList<PackingInformation>> CreateDictionaryRandomly(int items, int nrOfBins, IRandom random) {
+      var result = new ObservableDictionary<int, ItemList<PackingInformation>>();
+      for (int i = 0; i < nrOfBins; i++)
+        result[i] = new ItemList<PackingInformation>();
+
+      Permutation randomItemSequence = new Permutation(PermutationTypes.Absolute, items, random);
+      foreach (int i in randomItemSequence) {
+        result[random.Next(nrOfBins)].Add(new PackingInformation(i, random.Next(100) > 60 ? true : false));
       }
       return result;
     }
 
-    public static ItemList<PackingInformation> CreateListRandomlyWithSortedSequence(int items, int lowerBound, IRandom random) {
-      Permutation permutation = new Permutation(PermutationTypes.Absolute, items);
-      var result = new ItemList<PackingInformation>();
-      foreach (int itemIndex in permutation) {
-        result.Add(new PackingInformation(itemIndex, random.Next(0, lowerBound + 1), false));
+    public static ObservableDictionary<int, ItemList<PackingInformation>> CreateDictionaryRandomlyWithSortedSequence(int items, int nrOfBins, IRandom random) {
+      var result = new ObservableDictionary<int, ItemList<PackingInformation>>();
+      for (int i = 0; i < nrOfBins; i++)
+        result[i] = new ItemList<PackingInformation>();
+
+      for (int i = 0; i < items; i++) {
+        result[random.Next(nrOfBins)].Add(new PackingInformation(i, false));
       }
       return result;
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/MultiComponentVectorRandomCreator.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/MultiComponentVectorRandomCreator.cs	(revision 9494)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/MultiComponentVectorRandomCreator.cs	(revision 9495)
@@ -70,7 +70,7 @@
 			var solution = new MultiComponentVectorEncoding();
 			if (sortedSequence)
-				solution.PackingInformations = PackingInformation.CreateListRandomlyWithSortedSequence(items, lowerBound, random);
+				solution.PackingInformations = PackingInformation.CreateDictionaryRandomlyWithSortedSequence(items, lowerBound, random);
 			else
-				solution.PackingInformations = PackingInformation.CreateListRandomly(items, lowerBound, random);
+				solution.PackingInformations = PackingInformation.CreateDictionaryRandomly(items, lowerBound, random);
 			return solution;
 		}
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/SequencePreservingMultiComponentVectorCrossover.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/SequencePreservingMultiComponentVectorCrossover.cs	(revision 9495)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/SequencePreservingMultiComponentVectorCrossover.cs	(revision 9495)
@@ -0,0 +1,96 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using HeuristicLab.Collections;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Problems.BinPacking.Interfaces;
+
+namespace HeuristicLab.Encodings.PackingEncoding.MultiComponentVector {
+  [Item("Sequence Preserving Multi Component Vector Crossover", "An operator which crosses two MultiComponentVector representations.")]
+  [StorableClass]
+  public class SequencePreservingMultiComponentVectorCrossover :  MultiComponentVectorCrossover {
+    [StorableConstructor]
+    protected SequencePreservingMultiComponentVectorCrossover(bool deserializing) : base(deserializing) { }
+    protected SequencePreservingMultiComponentVectorCrossover(SequencePreservingMultiComponentVectorCrossover original, Cloner cloner) : base(original, cloner) { }
+    public SequencePreservingMultiComponentVectorCrossover()
+      : base() {
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new SequencePreservingMultiComponentVectorCrossover(this, cloner);
+    }
+
+    public override MultiComponentVectorEncoding Cross(IRandom random, MultiComponentVectorEncoding parent1, MultiComponentVectorEncoding parent2) {
+      MultiComponentVectorEncoding child = new MultiComponentVectorEncoding ();
+      int nrOfItems = parent1.NrOfItems;
+      bool[] itemAlreadyAssigned = new bool[nrOfItems];
+
+      bool useParent2 = false;
+      int nrOfBins = parent1.NrOfBins > parent2.NrOfBins ? parent2.NrOfBins : parent1.NrOfBins;
+      for (int binNr = 0; binNr < nrOfBins; binNr++) { 
+        MultiComponentVectorEncoding currentParent1 = useParent2 ? parent2 : parent1;
+        MultiComponentVectorEncoding currentParent2 = useParent2 ? parent1 : parent2;
+
+                  
+        var newBin = new ItemList<PackingInformation>();
+        double crossPointPercent = 0;
+
+        int nrOfItems1 = currentParent1.PackingInformations[binNr].Count;
+        if (nrOfItems1 > 0) {
+          double crossPoint1 = random.Next(nrOfItems1);
+          crossPointPercent = crossPoint1 / nrOfItems1; 
+          for (int i = 0; i < crossPoint1; i++) {
+            PackingInformation pi = new PackingInformation(currentParent1.PackingInformations[binNr][i]);
+            if (!itemAlreadyAssigned[pi.ItemID]) {
+              itemAlreadyAssigned[pi.ItemID] = true;
+              newBin.Add(new PackingInformation(pi));
+            }
+          }
+        }
+
+        int nrOfItems2 = currentParent2.PackingInformations[binNr].Count;
+        if (nrOfItems2 > 0) {
+          int crossPoint2 = Convert.ToInt32(nrOfItems2 * crossPointPercent);
+          for (int i = crossPoint2; i < nrOfItems2; i++) {
+            PackingInformation pi = new PackingInformation(currentParent2.PackingInformations[binNr][i]);
+            if (!itemAlreadyAssigned[pi.ItemID]) {
+              itemAlreadyAssigned[pi.ItemID] = true;
+              newBin.Add(new PackingInformation(pi));
+            }
+          }
+        }
+
+        child.PackingInformations[binNr] = newBin;    
+        useParent2 = !useParent2;
+      }
+
+      for (int itemID = 0; itemID < nrOfItems; itemID++) {
+        if (!itemAlreadyAssigned[itemID])
+          child.PackingInformations[random.Next(nrOfBins)].Add(new PackingInformation(itemID, random.Next(2) == 0 ? true : false));
+      }
+
+      return child;
+    }       
+  }
+}
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/ThreeWayMultiComponentVectorManipulator.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/ThreeWayMultiComponentVectorManipulator.cs	(revision 9494)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/ThreeWayMultiComponentVectorManipulator.cs	(revision 9495)
@@ -28,5 +28,5 @@
 
 namespace HeuristicLab.Encodings.PackingEncoding.MultiComponentVector {
-  [Item("Uniform Multi Component Vector Manipulator", "An operator which manipulates a PackingSequence representation.")]
+  [Item("ThreeWayMultiComponentVectorManipulator", "An operator which manipulates a PackingSequence representation.")]
   [StorableClass]
   public class ThreeWayMultiComponentVectorManipulator :  MultiComponentVectorManipulator {
@@ -43,34 +43,30 @@
     protected override void Manipulate(IRandom random, MultiComponentVectorEncoding individual) {
       int manipulatorDecision = random.Next(0, 3);
+      int affectedBin = 0;
+      do {  
+        affectedBin = random.Next(individual.NrOfBins);
+      } while (individual.PackingInformations[affectedBin].Count <= 0);
+      int affectedIndex = random.Next (individual.PackingInformations[affectedBin].Count);
 
       //Randomly rotate one item
       if (manipulatorDecision == 0) {
-        bool r = individual.PackingInformations[random.Next(individual.PackingInformations.Count - 1)].Rotated;
-        individual.PackingInformations[random.Next(individual.PackingInformations.Count - 1)].Rotated = !r;
+        individual.PackingInformations = SingleItemRotationMove.GetVectorAfterMove(individual, affectedBin, affectedIndex).PackingInformations;
       } 
       //Randomly change the bin-assignment for one item
       else if (manipulatorDecision == 1) {
-        individual.PackingInformations[random.Next(individual.PackingInformations.Count - 1)].AssignedBin = 0;
+        int targetBin = 0;
+        if (individual.NrOfBins > 1)
+          do { targetBin = random.Next(individual.NrOfBins); }
+          while (targetBin != affectedBin);
+        individual.PackingInformations = SingleGroupingMove.GetVectorAfterMove(individual, affectedBin, affectedIndex, targetBin).PackingInformations;
       }
       //Swap the sequence of two items assigned to the same bin
       else if (manipulatorDecision == 2) {
-        int length = individual.PackingInformations.Count;
-
-        int counter = 0;
-        int swappedIndex1 = random.Next(length); 
-        int swappedIndex2 = random.Next(length);
-        while ((swappedIndex1 == swappedIndex2 || individual.PackingInformations[swappedIndex1].AssignedBin != individual.PackingInformations[swappedIndex2].AssignedBin) && counter < 10)
-        {
-          swappedIndex1 = random.Next(length); 
-          swappedIndex2 = random.Next(length);
-          counter++;
-        }
-
-        if (swappedIndex1 != swappedIndex2 && individual.PackingInformations[swappedIndex1].AssignedBin == individual.PackingInformations[swappedIndex2].AssignedBin) {
-          int temp = individual.PackingInformations[swappedIndex1].ItemIndex;
-          individual.PackingInformations[swappedIndex1].ItemIndex = individual.PackingInformations[swappedIndex2].ItemIndex;
-          individual.PackingInformations[swappedIndex2].ItemIndex = temp;
-        }
-
+        int targetIndex = 0;
+        int nrOfItems = individual.PackingInformations[affectedBin].Count;
+        if (nrOfItems > 1)
+          do { targetIndex = random.Next(nrOfItems); }
+          while (targetIndex != affectedIndex);
+        individual.PackingInformations = ChangePositionMove.GetVectorAfterMove(individual, affectedBin, affectedIndex, targetIndex).PackingInformations;
       }
 
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingPlans/PackingPlan.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingPlans/PackingPlan.cs	(revision 9494)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingPlans/PackingPlan.cs	(revision 9495)
@@ -60,13 +60,7 @@
     [Storable]
     public ObservableDictionary<int, D> PackingItemPositions { get; set; }
+    [Storable]
+    public ObservableDictionary<int, B> PackingBinMeasures { get; set; }
 
-    //[Storable]
-    //public ItemList<BoolValue> PackingItemsRotated { get; set; }
-
-    [Storable]
-    public B PackingBinMeasures {
-      get;
-      set;
-    }
     [Storable]
     public ItemList<I> PackingItemMeasures {
@@ -89,7 +83,14 @@
     #endregion
 
-    public PackingPlan(B binMeasures, ItemList<I> itemMeasures) : base() {
+    public PackingPlan(B binMeasures, ItemList<I> itemMeasures)
+      : base() {
+      this.PackingItemMeasures = itemMeasures;
+      this.PackingBinMeasures = new ObservableDictionary<int, B>();
+      this.PackingBinMeasures[0] = binMeasures;
+    }
+    public PackingPlan(ObservableDictionary<int, B> binMeasures, ItemList<I> itemMeasures)
+      : base() {
+      this.PackingItemMeasures = itemMeasures;
       this.PackingBinMeasures = binMeasures;
-      this.PackingItemMeasures = itemMeasures;
     }
 
@@ -98,12 +99,17 @@
     protected PackingPlan(PackingPlan<D,B,I> original, Cloner cloner)
       : base(original, cloner) {
-        PackingItemPositions = new ObservableDictionary<int, D>(original.PackingItemPositions);
-      PackingBinMeasures = original.PackingBinMeasures;
+      PackingItemPositions = new ObservableDictionary<int, D>(original.PackingItemPositions);
+      PackingBinMeasures = new ObservableDictionary<int, B>(original.PackingBinMeasures);
       PackingItemMeasures = original.PackingItemMeasures;
-      //PackingItemsRotated = cloner.Clone(original.PackingItemsRotated);
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new PackingPlan<D,B,I>(this, cloner);
     }
 
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new PackingPlan<D,B,I>(this, cloner);
+    public B GetPackingBinMeasuresForBinNr(int binNr) {
+      if (PackingBinMeasures.ContainsKey(binNr))
+        return PackingBinMeasures[binNr];
+      else
+        return PackingBinMeasures[0];
     }
 
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Evaluators/Abstract/BinUtilizationRegularIdenticalBinEvaluator.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Evaluators/Abstract/BinUtilizationRegularIdenticalBinEvaluator.cs	(revision 9494)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Evaluators/Abstract/BinUtilizationRegularIdenticalBinEvaluator.cs	(revision 9495)
@@ -66,10 +66,10 @@
 
       //if (itemPositionsAreValid)
-      return CalculateBinUtilization(plan as PackingPlan<D, B, I>, binMeasure, itemMeasures);
+      return CalculateBinUtilization(plan as SingleBinSizePackingPlan<D, B, I>, binMeasure, itemMeasures);
 
       //return quality;
     }
 
-    public static DoubleValue CalculateBinUtilization(PackingPlan<D, B, I> plan, B binMeasure, ItemList<I> itemMeasures) {
+    public static DoubleValue CalculateBinUtilization(SingleBinSizePackingPlan<D, B, I> plan, B binMeasure, ItemList<I> itemMeasures) {
       int nrOfBins = plan.NrOfBins;
       double result = 0;
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/HeuristicLab.Problems.BinPacking-3.3.csproj
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/HeuristicLab.Problems.BinPacking-3.3.csproj	(revision 9494)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/HeuristicLab.Problems.BinPacking-3.3.csproj	(revision 9495)
@@ -176,7 +176,4 @@
     <Compile Include="Decoders\3D\DBL\DeepestBottomLeftMultiComponentVectorDecoder.cs" />
     <Compile Include="Decoders\3D\DBL\DeepestBottomLeftFunctions.cs" />
-    <Compile Include="Decoders\3D\EP\ExtremePointPotvinDecoder3D.cs">
-      <SubType>Code</SubType>
-    </Compile>
     <Compile Include="Decoders\3D\EP\ExtremePointsFunctions3D.cs" />
     <Compile Include="Decoders\3D\DBL\DeepestBottomLeftGroupingVectorDecoder.cs" />
@@ -184,7 +181,6 @@
     <Compile Include="Decoders\3D\DBL\DeepestBottomLeftPackingSequenceDecoder.cs" />
     <Compile Include="Decoders\2D\BL\BottomLeftPackingSequenceDecoder.cs" />
-    <Compile Include="Decoders\IdenticalBinPackingSolutionDecoder.cs" />
+    <Compile Include="Decoders\PackingSolutionDecoder.cs" />
     <Compile Include="Encodings\GroupingVector\Moves\SingleGrouping\SingleGroupingMoveSoftTabuCriterion.cs" />
-    <Compile Include="Encodings\GroupingVector\Moves\SingleGrouping\ExhaustiveTargetBinSingleGroupingMoveGenerator.cs" />
     <Compile Include="Encodings\GroupingVector\Moves\SingleGrouping\ExhaustiveSingleGroupingMoveGenerator.cs" />
     <Compile Include="Encodings\GroupingVector\Moves\SingleGrouping\SingleGroupingMove.cs" />
@@ -194,4 +190,5 @@
     <Compile Include="Encodings\GroupingVector\Moves\SingleGrouping\SingleGroupingTabuMaker.cs" />
     <Compile Include="Encodings\GroupingVector\Moves\SingleGrouping\SingleGroupingMoveHardTabuCriterion.cs" />
+    <Compile Include="Encodings\GroupingVector\Moves\SingleGrouping\StochasticSingleGroupingMoveGenerator.cs" />
     <Compile Include="Encodings\GroupingVector\UniformGroupingVectorManipulator.cs" />
     <Compile Include="Encodings\GroupingVector\GroupingVectorCrossover.cs" />
@@ -199,4 +196,5 @@
     <Compile Include="Encodings\GroupingVector\GroupingVectorManipulator.cs" />
     <Compile Include="Encodings\GroupingVector\GroupingVectorRandomCreator.cs" />
+    <Compile Include="Encodings\MultiComponentVector\SequencePreservingMultiComponentVectorCrossover.cs" />
     <Compile Include="Encodings\MultiComponentVector\Moves\ThreeWay\Attributes\ChangePositionMoveAttribute.cs" />
     <Compile Include="Encodings\MultiComponentVector\Moves\ThreeWay\Attributes\MCVTripleMoveAttribute.cs" />
@@ -223,5 +221,4 @@
       <SubType>Code</SubType>
     </Compile>
-    <Compile Include="Encodings\MultiComponentVector\PartiallyMatchedMultiComponentVectorCrossover.cs" />
     <Compile Include="Encodings\MultiComponentVector\MultiComponentVectorCrossover.cs" />
     <Compile Include="Encodings\MultiComponentVector\MultiComponentVectorManipulator.cs" />
@@ -236,15 +233,6 @@
     <Compile Include="Encodings\PackingSolutionCrossover.cs" />
     <Compile Include="Encodings\PackingSolutionManipulator.cs" />
-    <Compile Include="Encodings\Potvin\PotvinEncoding.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="Encodings\Potvin\PotvinRandomCreator.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="Evaluators\2D\BinUtilizationRectangularIdenticalBinEvaluator.cs" />
     <Compile Include="Evaluators\2D\PackingRatioRectangularIdenticalBinEvaluator.cs" />
-    <Compile Include="Evaluators\3D\BinUtilizationCuboiddenticalBinEvaluator.cs" />
     <Compile Include="Evaluators\3D\PackingRatioCuboidIdenticalBinEvaluator.cs" />
-    <Compile Include="Evaluators\Abstract\BinUtilizationRegularIdenticalBinEvaluator.cs" />
     <Compile Include="Evaluators\Abstract\PackingRatioRegularIdenticalBinEvaluator.cs" />
     <Compile Include="Evaluators\Abstract\RegularSimpleRotationIdenticalBinPackingPlanEvaluator.cs" />
@@ -257,4 +245,7 @@
     <Compile Include="Instances\BPPORLIBParser.cs" />
     <Compile Include="Instances\BPPORLIBDataDescriptor.cs" />
+    <Compile Include="Interfaces\I3DOperator.cs" />
+    <Compile Include="Interfaces\I2DOperator.cs" />
+    <Compile Include="Interfaces\IPackingMove.cs" />
     <Compile Include="Interfaces\IPotvinOperator.cs" />
     <Compile Include="Interfaces\IMultiComponentVectorMoveOperator.cs" />
@@ -274,8 +265,19 @@
     <Compile Include="Interfaces\IPackingShape.cs" />
     <Compile Include="Interfaces\IPackingDimensions.cs" />
-    <Compile Include="MoveEvaluators\MultiComponentVectorMoveEvaluator.cs" />
     <Compile Include="MoveEvaluators\PackingMoveEvaluator.cs" />
-    <Compile Include="MoveEvaluators\GroupingVectorMoveEvaluator.cs" />
+    <Compile Include="MoveEvaluators\PackingMoveEvaluator2DGV.cs">
+      <SubType>Code</SubType>
+    </Compile>
+    <Compile Include="MoveEvaluators\PackingMoveEvaluator2DMCV.cs">
+      <SubType>Code</SubType>
+    </Compile>
+    <Compile Include="MoveEvaluators\PackingMoveEvaluator3DGV.cs">
+      <SubType>Code</SubType>
+    </Compile>
+    <Compile Include="MoveEvaluators\PackingMoveEvaluator3DMCV.cs">
+      <SubType>Code</SubType>
+    </Compile>
     <Compile Include="Problem\BinPackingProblem.cs" />
+    <Compile Include="Problem\ISOContainerBinPackingProblem.cs" />
     <Compile Include="Problem\CuboidIdenticalBinPackingProblem.cs" />
     <Compile Include="Problem\RegularIdenticalBinPackingProblem.cs" />
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Interfaces/I2DOperator.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Interfaces/I2DOperator.cs	(revision 9495)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Interfaces/I2DOperator.cs	(revision 9495)
@@ -0,0 +1,31 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.Problems.BinPacking.Interfaces {
+  public interface I2DOperator {
+  }
+}
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Interfaces/I3DOperator.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Interfaces/I3DOperator.cs	(revision 9495)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Interfaces/I3DOperator.cs	(revision 9495)
@@ -0,0 +1,31 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.Problems.BinPacking.Interfaces {
+  public interface I3DOperator {
+  }
+}
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Interfaces/IPackingMove.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Interfaces/IPackingMove.cs	(revision 9495)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Interfaces/IPackingMove.cs	(revision 9495)
@@ -0,0 +1,30 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Optimization;
+
+namespace HeuristicLab.Problems.BinPacking.Interfaces  {
+  public interface IPackingMove : IItem {
+    IPackingSolutionEncoding GetSolutionAfterMove();
+  }
+}
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/MoveEvaluators/GroupingVectorMoveEvaluator.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/MoveEvaluators/GroupingVectorMoveEvaluator.cs	(revision 9494)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/MoveEvaluators/GroupingVectorMoveEvaluator.cs	(revision 9495)
@@ -68,4 +68,6 @@
 
       var packingPlan = ExtremePointGroupingVectorDecoder3D.Decode(newSolution, PackingBinMeasuresParameter.ActualValue, PackingItemMeasuresParameter.ActualValue);
+      CurrentScopeParameter.ActualValue.Variables.Add(new Variable("PackingPlanAfterMove", packingPlan));
+
       DoubleValue quality = PackingRatioRegularIdenticalBinEvaluator<ThreeDimensionalPacking, CuboidPackingBin, CuboidPackingItem>.CalculatePackingRatio(
         packingPlan, PackingBinMeasuresParameter.ActualValue, PackingItemMeasuresParameter.ActualValue);
